class type ['a] bimap_t =
  object
     method card : int
     method lkup : 'a -> int
     method enum : int -> 'a
     method list : 'a list
  end;;

let buildbimap l = match l with
    [] -> (0,
           (function _ -> raise Not_found),
           (function _ -> raise (Invalid_argument "Array.get")))
  | x::l -> let n = List.length (x::l) in 
            let h = Hashtbl.create n
            and t = Array.create n x in
            let rec loop k = function
                []   -> ()
              | y::l -> (Hashtbl.add h y k; Array.set t k y; loop (k+1) l) in
            let _ = loop 0 (x::l)
            in (n,Hashtbl.find h,Array.get t);;

class ['a] bimap (l:'a list) = 
  let (n,h,t) = buildbimap l
  in object
     method card = n
     method lkup = h
     method enum = t
     method list = l
  end;;
