type pola    = Plus | Minus
type color   = Green | Red
type arrow   = int*int*color*((bool*int) option)
type atom    = Bot | Box | Var of string

type node    = Intrn of Formula.conn*pola*int*int
             | Leaf  of atom*pola
             | Extrn of atom

class type bc_graph =
  object
    method bot      : int
    method top      : int
    method size     : int
    method vars     : int list
    method name     : int -> string
    method arrows   : arrow list
    method choices  : int list
    method node     : int -> node
  end

class form_graph : Formula.form -> bc_graph

val print : bc_graph -> unit

val extract : bc_graph -> (int*bool) list -> color -> (int*int) list
