let usage = "cmodels [-log L] (for L=0,1,2)\n" ^
            "        [-alg A] (for A=0,1)\n";;

let algo = ref 0;;

let _ = Arg.parse [("-log",Arg.Set_int Compute.loglevel,"Sets the log level");
                   ("-alg",Arg.Set_int algo,"Algo: 0 (sum,default) or 1 (trace)")] (fun _->()) usage;;

let l = !Compute.loglevel
in  if l<0 or l>2
    then Compute.loglevel := 0
    else ();;

if   (!algo)!=1 
then algo := 0
else ();;
           
Printf.printf "Log level set to %d\n" !Compute.loglevel;;

let rec print_cm = function
  | []       -> Printf.printf "\n"
  | (s,v)::l -> Printf.printf "%s=%d, " s v; print_cm l;;

let print_m = function
  | None   -> Printf.printf "The formula is provable, so has no counter-model\n"
  | Some l -> Printf.printf "A counter-model is : "; print_cm l;;

let compute () =
  let f = Syntax.parse_stdin ()     in
  let g = new Cgraph.form_graph f   in
  let _ = Cgraph.print g            in  
  let m = if   (!algo)=1
          then Compute.trace g
          else Compute.sum g
  in  print_m m;;

compute ();;