type conn = Conj | Disj | Imp;;

type form = False | True | Atm of string | Comp of conn*form*form;;

let rec form_size = function 
    Comp (_,l,r) -> (form_size l)+(form_size r)+1
  | _            -> 1;;

module SSet = Set.Make(String);;

let form_vars f =
  let rec loop s = function 
    Comp (_,l,r) -> loop (loop s l) r
  | Atm  a       -> SSet.add a s 
  | _            -> s in  
  let s = loop SSet.empty f 
  in  SSet.elements s;;

let rec connrec c e = function
    []   -> e
  | x::l -> Comp (c,connrec c e l, Atm x);;

