(* 

Sorting routine : Sort.sort max green red 

max   : int
green : (int*int) list 
red   : (int*int) list

represent a direct graph of at most max nodes
numbered from 0 to (max-1) with green and red
arrows.

the result is a topological sort giving an preorder
<= such that for any green arrow (i,j), the
condition i <= j is fulfilled and for any red arrow
(i,j), the condition i<j is fulfilled

for example, the result :

[[0;2];[3];[1;4]] represents the preorder

0<=>2, 0<3, 3<1, 1<=>4

If there exists a cycle containing at least one
red arrow, then no topological sort exists and the
result has to be ignored.

The routine does not check for this case. It could
be done easily and efficiently but it is not 
necessary for our purpose.

*)

val tsort : int -> (int*int) list -> int list

val sort  : int -> (int*int) list -> (int*int) list -> int list list

val height  : int -> (int*int) list -> (int*int) list -> int list * (int * int) list
